//-----------------------------------------------------------------------------
// Torque Game Engine 
// Copyright (C) GarageGames.com, Inc.
//-----------------------------------------------------------------------------

// Load dts shapes and merge animations
datablock TSShapeConstructor(RobotDts)
{
	baseShape  = "./Robot.dts";
	sequence0  = "./R_root.dsq root";

	sequence1  = "./R_walk.dsq run";
	sequence2  = "./R_walk.dsq walk";
	sequence3  = "./R_root.dsq back";
	sequence4  = "./R_root.dsq side";

	sequence5  = "./R_root.dsq crouch";
	sequence6  = "./R_root.dsq crouchRun";
	sequence7  = "./R_root.dsq crouchBack";
	sequence8  = "./R_root.dsq crouchSide";

	sequence9  = "./R_root.dsq look";
	sequence10 = "./R_root.dsq headside";
	sequence11 = "./R_root.dsq headUp";

	sequence12 = "./R_root.dsq jump";
	sequence13 = "./R_root.dsq standjump";
	sequence14 = "./R_root.dsq fall";
	sequence15 = "./R_root.dsq land";

	sequence16 = "./R_root.dsq armAttack";
	sequence17 = "./R_armReadyLeft.dsq armReadyLeft";
	sequence18 = "./R_armReadyRight.dsq armReadyRight";
	sequence19 = "./R_armReadyBoth.dsq armReadyBoth";
	sequence20 = "./R_root.dsq spearready";  
	sequence21 = "./R_root.dsq spearThrow";

	sequence22 = "./R_root.dsq talk";  

	sequence23 = "./R_death1.dsq death1"; 
	
	sequence24 = "./R_root.dsq shiftUp";
	sequence25 = "./R_root.dsq shiftDown";
	sequence26 = "./R_root.dsq shiftAway";
	sequence27 = "./R_root.dsq shiftTo";
	sequence28 = "./R_root.dsq shiftLeft";
	sequence29 = "./R_root.dsq shiftRight";
	sequence30 = "./R_root.dsq rotCW";
	sequence31 = "./R_root.dsq rotCCW";

	sequence32 = "./R_root.dsq undo";
	sequence33 = "./R_root.dsq plant";

	sequence34 = "./R_root.dsq sit";

	sequence35 = "./R_root.dsq wrench";

   sequence36 = "./R_root.dsq activate";
   sequence37 = "./R_root.dsq activate2";

   sequence38 = "./R_root.dsq leftrecoil";
};    

datablock DebrisData( RobotDebris )
{
   explodeOnMaxBounce = false;

   elasticity = 0.15;
   friction = 0.5;

   lifetime = 4.0;
   lifetimeVariance = 0.0;

   minSpinSpeed = 40;
   maxSpinSpeed = 600;

   numBounces = 5;
   bounceVariance = 0;

   staticOnMaxBounce = true;
   gravModifier = 1.0;

   useRadiusMass = true;
   baseRadius = 1;

   velocity = 20.0;
   velocityVariance = 12.0;
};             

datablock PlayerData(RobotArmor)
{
   renderFirstPerson = false;
   emap = false;
   
   className = Armor;
   shapeFile = "./Robot.dts";
   cameraMaxDist = 8;
   cameraTilt = 0.261;//0.174 * 2.5; //~25 degrees
   cameraVerticalOffset = 2.3;
     
   cameraDefaultFov = 90.0;
   cameraMinFov = 5.0;
   cameraMaxFov = 120.0;
   
   //debrisShapeName = "~/data/shapes/player/debris_player.dts";
   //debris = RobotDebris;

   aiAvoidThis = true;

   minLookAngle = -1.5708;
   maxLookAngle = 1.5708;
   maxFreelookAngle = 3.0;

   mass = 90;
   drag = 0.1;
   density = 0.7;
   maxDamage = 250;
   maxEnergy =  10;
   repairRate = 0.33;

   rechargeRate = 0.4;

   runForce = 14 * 45;
   runEnergyDrain = 0;
   minRunEnergy = 0;
   maxForwardSpeed = 6;
   maxBackwardSpeed = 3;
   maxSideSpeed = 1;

   maxForwardCrouchSpeed = 3;
   maxBackwardCrouchSpeed = 3;
   maxSideCrouchSpeed = 1;

   maxForwardProneSpeed = 0;
   maxBackwardProneSpeed = 0;
   maxSideProneSpeed = 0;

   maxForwardWalkSpeed = 0;
   maxBackwardWalkSpeed = 0;
   maxSideWalkSpeed = 0;

   maxUnderwaterForwardSpeed = 8.4;
   maxUnderwaterBackwardSpeed = 7.8;
   maxUnderwaterSideSpeed = 7.8;

   jumpForce = 0;
   jumpEnergyDrain = 0;
   minJumpEnergy = 0;
   jumpDelay = 0;

   minJetEnergy = 0;
	jetEnergyDrain = 0;
	canJet = 0;

   minImpactSpeed = 250;
   speedDamageScale = 3.8;

   boundingBox			= vectorScale("2.5 2.5 2.4", 4);
   crouchBoundingBox	= vectorScale("2.5 2.5 2.4", 4);
   
   pickupRadius = 0.75;
   
   // Foot Prints
   //decalData   = RobotFootprint;
   //decalOffset = 0.25;
	
   jetEmitter = "";
   jetGroundEmitter = "";
   jetGroundDistance = 4;
  
   //footPuffEmitter = LightPuffEmitter;
   footPuffNumParts = 10;
   footPuffRadius = 0.25;

   //dustEmitter = LiftoffDustEmitter;

   splash = PlayerSplash;
   splashVelocity = 4.0;
   splashAngle = 67.0;
   splashFreqMod = 300.0;
   splashVelEpsilon = 0.60;
   bubbleEmitTime = 0.1;
   splashEmitter[0] = PlayerFoamDropletsEmitter;
   splashEmitter[1] = PlayerFoamEmitter;
   splashEmitter[2] = PlayerBubbleEmitter;
   mediumSplashSoundVelocity = 10.0;   
   hardSplashSoundVelocity = 20.0;   
   exitSplashSoundVelocity = 5.0;

   // Controls over slope of runnable/jumpable surfaces
   runSurfaceAngle  = 85;
   jumpSurfaceAngle = 86;

   minJumpSpeed = 20;
   maxJumpSpeed = 30;

   horizMaxSpeed = 68;
   horizResistSpeed = 33;
   horizResistFactor = 0.35;

   upMaxSpeed = 80;
   upResistSpeed = 25;
   upResistFactor = 0.3;
   
   footstepSplashHeight = 0.35;

   //NOTE:  some sounds commented out until wav's are available

   JumpSound			= RobotJumpSound;

   // Footstep Sounds
//   FootSoftSound        = RobotFootFallSound;
//   FootHardSound        = RobotFootFallSound;
//   FootMetalSound       = RobotFootFallSound;
//   FootSnowSound        = RobotFootFallSound;
//   FootShallowSound     = RobotFootFallSound;
//   FootWadingSound      = RobotFootFallSound;
//   FootUnderwaterSound  = RobotFootFallSound;
   //FootBubblesSound     = FootLightBubblesSound;
   //movingBubblesSound   = ArmorMoveBubblesSound;
   //waterBreathSound     = WaterBreathMaleSound;

   //impactSoftSound      = ImpactLightSoftSound;
   //impactHardSound      = ImpactLightHardSound;
   //impactMetalSound     = ImpactLightMetalSound;
   //impactSnowSound      = ImpactLightSnowSound;
   
   impactWaterEasy      = Splash1Sound;
   impactWaterMedium    = Splash1Sound;
   impactWaterHard      = Splash1Sound;
   
   groundImpactMinSpeed    = 10.0;
   groundImpactShakeFreq   = "4.0 4.0 4.0";
   groundImpactShakeAmp    = "1.0 1.0 1.0";
   groundImpactShakeDuration = 0.8;
   groundImpactShakeFalloff = 10.0;
   
   //exitingWater         = ExitingWaterLightSound;

   // Inventory Items
	maxItems   = 10;	//total number of bricks you can carry
	maxWeapons = 5;		//this will be controlled by mini-game code
	maxTools = 5;
	
	uiName = "Robot";
	rideable = false;
		lookUpLimit = 0.6;
		lookDownLimit = 0.2;

	canRide = false;
	showEnergyBar = false;
	paintable = true;

	brickImage = RobotBrickImage;	//the imageData to use for brick deployment

   numMountPoints = 1;
   mountThread[0] = "root";
   mountNode[0] = 2;
};

function Robot::onDisabled(%this,%obj,%state)
{
   %p = new Projectile()
   {
      dataBlock = VehicleFinalExplosionProjectile;
      initialPosition = %obj.gettransform();
      initialVelocity = "0 0 1";
      client = %obj.lastDamageClient;
      sourceClient = %obj.lastDamageClient;
   };
   MissionCleanup.add(%p);

   %obj.schedule(3000,removebody);
   %player = %obj.getMountedObject(0);

   %obj.burn(5);
}